
var action = "save";
var tableData = undefined;
var GRN_ID = undefined;
var REFFERANCE_ID = undefined;
var EXTERNAL_ID = undefined;
$(document).ready(function () {


    var grnChooser = $('#grnChooser').dataChooser({
        "columns": [
            { "data": "id" },
            { "data": "value0" },
        ],
        columnDefs: [
            { width: 200, targets: 0 },
            { width: 300, targets: 1 },
        ],
    });

    var grn_data = allGrn();
    grnChooser.setDataSource(grn_data);



    var supplierChooser = $('#supplierChooser').dataChooser({
        "columns": [
            { "data": "id" },
            { "data": "value0" },
        ],
        columnDefs: [
            { width: 200, targets: 0 },
            { width: 300, targets: 1 },
        ],
    });

    var supplier_data = allSuppliers();
    supplierChooser.setDataSource(supplier_data);


    var productChooser = $('#productChooser').dataChooser({
        "columns": [
            { "data": "id" },
            { "data": "value0" },
            { "data": "value1" },
        ],
        columnDefs: [
            { width: 50, targets: 0 },
            { width: 200, targets: 1 },
            { width: 300, targets: 2 },
        ],
    });

    var product_data = allProduct();
    console.log(product_data);
    productChooser.setDataSource(product_data);




    tableData = $('#tblData').transactionTable({
        thead: ['ProductPrimaryID', 'ProductID', 'Product Name', 'Unit', 'Available Qty', 'Qty', 'Comment', 'Remove'],
        data_chooser: [{ 'col': 2 }],
        chooser: productChooser,
        column_def: { 1: 100 },
        auto_focus: 2,
        row_type: [
            { 'type': 'string', 'value': '', 'align': 'left', 'width': '100px' },
            { 'type': 'string', 'value': '', 'align': 'left', 'width': '100px' },
            { 'type': 'text', 'value': '', 'align': 'left', 'width': '100%' },
            {
                'type': 'select', 'value': [], 'align': 'left', 'width': '100px'
            },
            { 'type': 'string', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'text', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'text', 'value': '', 'align': 'left', 'width': '200px' },
            { 'type': 'remove', 'value': 'X', 'align': 'center', 'width': '50px' }],
    });




    productChooser.on('select', function (event, data) {
        var selected_row = tableData.getSelectedRow();
        var cells = selected_row.getElementsByTagName('td');
        cells[0].childNodes[0].value = data[0];
        cells[1].childNodes[0].value = data[1];
        cells[2].childNodes[0].value = data[2];
        cells[4].childNodes[0].value = getAvailableQty(data[0], $('#cmbStores').val());
        var input = productChooser.getInput();
        input.focus();


        var product_id = data[0];
        var uom = getProduct_Uom(product_id);
        $('#' + cells[3].childNodes[0].id).empty();
        $('#' + cells[3].childNodes[0].id).append('<option value="' + uom.id + '">' + uom.value + '</option>');
    });






    $('input[name="trans_date"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }

    });

    //allEmployees();
    allStores();
    newReferanceID($('#cmbStores').val());




    $('#btnSave').on('click', function () {


        if ($(this).text() == 'Save') {
            saveGoodsReturn();
        } else {
            //updateGoodsReturn();
        }
    });




    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split('?');
        var id = param[0].split('=')[1].split('&')[0];
        action = param[0].split('=')[2].split('&')[0];
        MI_ID = id;
        getGoodsReturn(id);
        if (action == 'edit') {
            $('#btnSave').text('Update');
        } else if (action == 'view') {
            $('#btnSave').hide();
        }

    } else {
        tableData.add_empty_row();
    }



    $('#txtgrn_id').on('input', function () {
        grnChooser.showChooser($(this));
    });


    $('#txtSupplier').on('input', function () {
        supplierChooser.showChooser($(this));
    });


    supplierChooser.on('select', function (event, data) {
        $('#txtSupplier').val(data[1]);
        $('#txtSupplier').attr("data-id", data[0]);
        var input = supplierChooser.getInput();
        input.focus();
    });


    grnChooser.on('select', function (event, data) {
        getGrn(data[0]);
        $('#txtgrn_id').val(data[0]);
        $('#txtgrn_id').attr("data-id", data[0]);
        var input = grnChooser.getInput();
        input.focus();
    });


    $('#cmbStores').on('change', function () {
        newReferanceID($(this).val());
    });


});





function allEmployees() {
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/allEmployees",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            var res = response.data.result;
            //console.log(res);
            //$('#txtReceivedBy').setData(res);
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}




function allStores() {
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/allStores",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $('#cmbStores').append('<option value="' + res[i].id + '">' + res[i].name + '</option>');
            }
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}



function newReferanceID(storeID) {
    var referanceID = newID("/sc/ReferenceIDController/grnReturnMaxID", storeID);
    EXTERNAL_ID = referanceID;
    $('#txtExternal_id').val(referanceID);
}







function allProduct() {
    var product_data = [];
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/allProduct",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            product_data = response.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });

    return product_data;
}




function saveGoodsReturn() {

    newReferanceID($('#cmbStores').val());
    var grn_data = {};
    var grn_data_arr = tableData.dataSource();
    for (var i = 0; i < grn_data_arr.length; i++) {
        grn_data[i] = JSON.stringify({ "product_id": grn_data_arr[i][0], "product_name": grn_data_arr[i][2], "unit_id": grn_data_arr[i][3], "qty": grn_data_arr[i][5], "comments": grn_data_arr[i][6], });
    }

    if (GRN_ID == undefined || REFFERANCE_ID == undefined) {
        showWarningMessage('Goods Return not selected...!');
        return;
    }


    var quantity_invalied = false;

    var row_count = $('#tblData >tr').length;
    for (var i = 1; i < row_count; i++) {
        var product_id = $('#tblData >tr').eq(i).find("td :input").eq(0).val();
        var store_id = $('#cmbStores').val();
        var available_qty = parseFloat(getAvailableQuantitySaveBefore(product_id, store_id));
        $('#tblData >tr').eq(i).find("td :input").eq(4).val(available_qty);
        if (isNaN(available_qty)) {
            available_qty = 0;
        }

        var qty = parseFloat($('#tblData >tr').eq(i).find("td :input").eq(5).val());
        if (isNaN(qty)) {
            qty = 0;
            $('#tblData >tr').eq(i).find("td :input").eq(5).val(0);
        }

        if (available_qty < qty) {
            quantity_invalied = true;
            $('#tblData >tr').eq(i).find("td :input").eq(5).css("background-color", "red");
            showWarningMessage('Stock balance  is insufficient');
        } else {
            $('#tblData >tr').eq(i).find("td :input").eq(5).css("background-color", "white");
        }

    }


    if (quantity_invalied) {
        return;
    }

    $.ajax({
        type: "POST",
        url: '/sc/grnReturnController/save',
        data: {
            'internal_id': GRN_ID,
            'external_id': EXTERNAL_ID,
            'ref_external_id': $('#txtExternal_id').val(),
            'trans_date': $('#txtGrnDate').val(),
            'supplier_Id': $('#txtSupplier').attr("data-id"),
            'received_by': $('#txtReceivedBy').val(),
            'store_id': $('#cmbStores').val(),
            'supplier_ref_no': $('#txtSupplierRefNo').val(),
            'purchase_order_no': $('#txtPurchase_order_no').val(),
            'transport_by': $('#txtTransport_by').val(),
            'vehicle_no': $('#txtVehicle_no').val(),
            'remarks': '',
            'grn_data': grn_data,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
        },
        success: function (response) {
            console.log(response);
            toastr.success('data saved');
            location.href = '/sc/goodsReturn';
            //location.reload();

        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
        }

    });
}






function updateGoodsReturn() {

    var grn_data = {};
    var grn_data_arr = tableData.dataSource();
    for (var i = 0; i < grn_data_arr.length; i++) {
        grn_data[i] = JSON.stringify({ "product_id": grn_data_arr[i][0], "product_name": grn_data_arr[i][2], "unit_id": grn_data_arr[i][3], "qty": grn_data_arr[i][5], "comments": grn_data_arr[i][6], });
    }


    if (GRN_ID == undefined || REFFERANCE_ID == undefined) {
        showWarningMessage('Goods Return not selected...!');
        return;
    }

    $.ajax({
        type: "PUT",
        url: '/sc/grnReturnController/update/' + GRN_ID,
        data: {
            'internal_id': GRN_ID,
            'external_id': EXTERNAL_ID,
            'ref_external_id': $('#txtExternal_id').val(),
            'trans_date': $('#txtGrnDate').val(),
            'supplier_Id': $('#txtSupplier').attr("data-id"),
            'received_by': $('#txtReceivedBy').optionID(),
            'store_id': $('#cmbStores').val(),
            'supplier_ref_no': $('#txtSupplierRefNo').val(),
            'purchase_order_no': $('#txtPurchase_order_no').val(),
            'transport_by': $('#txtTransport_by').val(),
            'vehicle_no': $('#txtVehicle_no').val(),
            'remarks': '',
            'grn_data': grn_data,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
        },
        success: function (response) {
            console.log(response);
            toastr.success('data updated');
            location.href = '/sc/goodsReturnList';
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
        }

    });
}





function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}





function getProduct_Uom(id) {
    var unit = undefined;
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/getUom/" + id,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            unit = response.data.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
    return unit;
}


function triggerRowInputs(id, selected_row) {

    if (id == "tblData") {
        var cells = selected_row.getElementsByTagName('td');
        var product = $('#' + cells[0].childNodes[0].id);
        var quantity = $('#' + cells[3].childNodes[0].id);
        quantity.on('input', function () {
            var av_qty = getAvailableQty(product.val(), $('#cmbStores').val());
            var qty = parseFloat(quantity.val());
            if (qty > av_qty) {
                showAlert("Available quantity is " + av_qty);
                quantity.val(av_qty);
            }
        });
    }

}




function getAvailableQty(product_id, store_id) {
    var qty = 0;
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/getQty/" + product_id + "/" + store_id,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            qty = response.data.result;
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {

        }

    });
    return qty;
}



function showAlert(message) {
    swal({
        title: message,
        //text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: true,
        dangerMode: true,
    });

    $('.swal-button').on('click', function () {

    });

}




function allGrn() {
    var grn_data = [];
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/allGrn",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            grn_data = response.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });

    return grn_data;
}




function allSuppliers() {
    var supplier_data = [];
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/allSuppliers",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            supplier_data = response.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
    return supplier_data;
}





function getGrn(id) {

    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/getGrn/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            GRN_ID = res.internal_id
            REFFERANCE_ID = res.external_id;
            //$('#txtExternal_id').val(res.external_id);
            $('#txtGrnDate').val(res.trans_date);
            $('#txtSupplier').attr("data-id", res.supplier_Id);
            $('#txtSupplier').val(res.supplier);
            $('#txtReceivedBy').val(res.employee_name);
            setSelectedOption('cmbStores', res.store_id);
            $('#txtSupplierRefNo').val(res.supplier_ref_no);
            $('#txtPurchase_order_no').val(res.purchase_order_no);
            $('#txtTransport_by').val(res.transport_by);
            $('#txtVehicle_no').val(res.vehicle_no);

            var request_data = res.data;
            tableData.clear();
            for (var i = 0; i < request_data.length; i++) {
                tableData.addRow(
                    [
                        { 'type': 'string', 'val': request_data[i].product_primary_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'string', 'val': request_data[i].product_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].product, 'align': 'left', 'width': '100%' },
                        {
                            'type': 'select', 'val': request_data[i].uom, 'align': 'left', 'width': '100px'
                        },
                        { 'type': 'string', 'val': getAvailableQty(request_data[i].product_primary_id, res.store_id), 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].quantity, 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].comments, 'align': 'left', 'width': '200px' },
                        { 'type': 'remove', 'val': 'X', 'align': 'center', 'width': '50px' }]
                );
            }

        },
        error: function (error) {
            console.log(error);
            progress(false);

        },
        complete: function () {
            progress(false);
        }

    });
}





function getGoodsReturn(id) {
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/getGoodsReturn/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            //progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            GRN_ID = res.internal_id
            REFFERANCE_ID = res.external_id;
            $('#txtExternal_id').val(res.external_id);
            $('#txtGrnDate').val(res.trans_date);
            $('#txtSupplier').attr("data-id", res.supplier_Id);
            $('#txtSupplier').val(res.supplier);
            $('#txtReceivedBy').val(res.employee_name);
            setSelectedOption('cmbStores', res.store_id);
            $('#txtSupplierRefNo').val(res.supplier_ref_no);
            $('#txtPurchase_order_no').val(res.purchase_order_no);
            $('#txtTransport_by').val(res.transport_by);
            $('#txtVehicle_no').val(res.vehicle_no);

            var request_data = res.data;
            for (var i = 0; i < request_data.length; i++) {
                tableData.addRow(
                    [
                        { 'type': 'string', 'val': request_data[i].product_primary_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'string', 'val': request_data[i].product_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].product, 'align': 'left', 'width': '100%' },
                        {
                            'type': 'select', 'val': request_data[i].uom, 'align': 'left', 'width': '100px'
                        },
                        { 'type': 'string', 'val': getAvailableQty(request_data[i].product_primary_id, res.store_id), 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].quantity, 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].comments, 'align': 'left', 'width': '200px' },
                        { 'type': 'remove', 'val': 'X', 'align': 'center', 'width': '50px' }]
                );
            }

        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {
            //progress(false);
        }

    });
}



function getAvailableQty(product_id, store_id) {
    var qty = 0;
    $.ajax({
        type: "GET",
        url: "/sc/grnReturnController/getQty/" + product_id + "/" + store_id,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            qty = response.data.result;
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {

        }

    });
    return qty;
}



/**
* generateID
* This function is used to generate id
* @param id This is the paramter to require id
*/
function generateID(id) {

    let pattern = {
        1: "0000",
        2: "000",
        3: "00",
        4: "0",
    };
    var length = Math.ceil(Math.log(id + 1) / Math.LN10);
    return pattern[length] + id;
}



/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}